"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ad_record_1 = require("../records/ad.record");
const db_1 = require("../utils/db");
const defaultObj = {
    name: '[Testowy-123]John',
    description: 'opisany john',
    price: 199,
    url: 'http://localhost:8080',
    lat: 16.44,
    lon: 33.11,
    clicksCounter: 0,
    secondUrl: '',
};
afterAll(() => __awaiter(void 0, void 0, void 0, function* () {
    yield db_1.pool.execute('delete from `ads` where `name` like "[Testowy-123]%"');
    yield db_1.pool.end();
}));
test('AdRecord returns data from database for one entry', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield ad_record_1.AdRecord.getOne('cda499fb-d619-11ec-9f07-3ecfab8190d4');
    expect(ad).toBeDefined();
    expect(ad.name).toBe('Testowy');
}));
test('AdRecord return null from database if not exist', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield ad_record_1.AdRecord.getOne('cda499fb-d619-11ec-9f07-3ecfab8190d4');
    expect(ad).toBeDefined();
    expect(ad.name).toEqual('Testowy');
}));
test('AdRecord.findAll returns array of found entries when searching for "a". return only small data.', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield ad_record_1.AdRecord.findAll('o');
    expect(ad).not.toEqual([]);
    expect(ad[0].id).toBeDefined();
    expect(ad[0].description).toBeUndefined();
}));
test('AdRecord insert new element to database.', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield new ad_record_1.AdRecord(defaultObj);
    yield ad.insert();
    expect(ad.id).toBeDefined();
    expect(typeof ad.id).toBe('string');
}));
test('AdRecord check is new element added to database.', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield new ad_record_1.AdRecord(defaultObj);
    yield ad.insert();
    const found = yield ad_record_1.AdRecord.getOne(ad.id);
    expect(found).toBeDefined();
    expect(found).not.toBeNull();
    expect(found.id).toBe(ad.id);
}));
//# sourceMappingURL=ad.test.js.map